/* this graph area is used by class Applett2 to display
   the slope field of DiffEq feature
   */

import java.awt.*;
import java.awt.geom.*;

public class GraphArea2 extends Canvas {

  Dimension dimensions; //the canvas dimensions

  private double xlow, xhigh, ylow, yhigh;
  private double DevideX, LabelX, DevideY, LabelY;
  private String expression;
  private double xScale, yScale;
  private Point2D.Double point; //the initial value
  private Point2D.Double MP; //the mouse position, the point at which the mouse is at


  boolean slopeFieldDrawer;//flags to determine which function to draw
  boolean trajectoryDrawer;
  boolean positionDisplay; //flags to display the mouse position coordinates


  public GraphArea2(double x_low, double x_high, double y_low, double y_high) {

      super();  // call Frame ctor, telling what to label the frame
      dimensions = getPreferredSize(); //=400,400 in this case

      slopeFieldDrawer=false;trajectoryDrawer=false;positionDisplay=false;


      xlow = x_low; xhigh = x_high; ylow = y_low; yhigh = y_high;
      DevideX = 1; LabelX = 1; DevideY = .1; LabelY = .5;
      expression = "";
      xScale = 1.0; yScale = 1.0;

    }

  public void setExpression(String s)
  {
	  expression = s;
  }
  public void setPoint(Point2D.Double p)
  {
	  double x = plottedX(p.getX());
	  double y = plottedY(p.getY());
	  point = new Point2D.Double(x,y);
  }

  public void setSlopeFieldDrawer(boolean b)
  {
	  slopeFieldDrawer=b;
  }

  public void setBoundaries(double x_low, double x_high, double y_low, double y_high)
  {
	  xlow = x_low;
	  xhigh = x_high;
	  ylow = y_low;
	  yhigh = y_high;

  }

  public void setTrajectoryDrawer(boolean b)
  {
  	  trajectoryDrawer=b;
  }


  public void setMP(Point2D.Double p)
  {
	  double x = plottedX(p.getX());
	  double y = plottedY(p.getY());
	  MP = new Point2D.Double(x,y);
  }


  public void setaxesDevisionsAndLabels(double dx,double lx,double dy,double ly)
  {
	  DevideX = dx; LabelX = lx; DevideY=dy; LabelY =ly;
  }

  public void setScales(double xsc, double ysc)
  {
	  xScale = xsc; yScale = ysc;
  }

  public void setPositionDisplay(boolean b)
  {
	  positionDisplay = b;
  }


  public double plottableX(double newx)
  {
	//be aware that the number of units that the origin
	//moves along x axis equals 0-(xlow)

	  double nXUnitsTranslated = 0-xlow; //translation
	  //calculating the xscale.
	  xScale = (xhigh-xlow)/dimensions.width;

	  double x = (newx + nXUnitsTranslated)/xScale;

	  return x;
  }
  public double plottedX(double oldx)
  {
	  //calculate the x cordinates relative to the existing coordinates
	  //after getting x from the applet from mouth click event
	  //it is the opposite of plottableX
	  double nXUnitsTranslated = 0-xlow;
	  xScale = (xhigh-xlow)/dimensions.width;

	  double x = (oldx*xScale)-nXUnitsTranslated;
	  return x;
  }

  public double plottableY(double newy)
  {
	  //
	  double nYUnitsTranslated = 0 +(yhigh);
	  //calculating the Y_Scale
	  yScale = (yhigh-ylow)/dimensions.height;
	  double y = (nYUnitsTranslated - newy)/yScale;
	  return y;
  }
  public double plottedY(double oldy)
  {
	  //opposite of plottableY
	  double nYUnitsTranslated = 0 +(yhigh);
	  yScale = (yhigh-ylow)/dimensions.height;
	  double y = ((oldy*yScale)- nYUnitsTranslated)*(-1);
	  return y;
  }

  static double xLowBoundFinder(double x)
  {// find the lowest x boundary to be labled
      boolean state = true; int i=0;
      double y = Math.floor(x);
  	  while(state)
  	  { if(Math.abs(y)<10) state = false;
  	    else{
			y = Math.floor(y/10); i++;

		}
	  }
	  return y*(10^i);
  }
  public void paintAxes(Graphics2D g)
  {
	  //double xOrigin, yOrigin;
	  Graphics2D g2d = (Graphics2D) g;
	  g2d.setColor(Color.white);
	  //g2d.setStroke( new BasicStroke( 2.0f ) );
  //y-axis
	  g2d.draw(new Line2D.Double(plottableX(0.0), plottableY(yhigh),
	                             plottableX(0.0), plottableY(ylow)));
  //devide y axi. there are three cases
  	  if(ylow<0 && yhigh<0)//ylow and yhigh are both -ve
  	  {
		  for(double i= 0.0; i>ylow; i-= DevideY)
		   g2d.draw(new Line2D.Double(plottableX(0.0)-2,plottableY(i),plottableX(0.0)+2,plottableY(i)));
		  for(double i= 0.0; i>ylow; i-= LabelY)
		  { g2d.draw(new Line2D.Double(plottableX(0.0)-5,plottableY(i),plottableX(0.0)+5,plottableY(i)));
		  	g2d.drawString(Double.toString(i), (float)plottableX(0)+7,(float)plottableY(i));
		  }
	  }
  	  else if(ylow>0 && yhigh>0)// both are +ve
  	  {
		  for(double i= 0.0; i<yhigh; i+= DevideY)
		   g2d.draw(new Line2D.Double(plottableX(0.0)-2,plottableY(i),plottableX(0.0)+2,plottableY(i)));
		  for(double i= 0.0; i<yhigh; i+= LabelY)
		  { g2d.draw(new Line2D.Double(plottableX(0.0)-5,plottableY(i),plottableX(0.0)+5,plottableY(i)));
		    g2d.drawString(Double.toString(i), (float)plottableX(0)+7,(float)plottableY(i));
		  }
	  }
  	  else // ylow is negative and yhigh is +ve
  	  {
		  for(double i= 0.0; i<yhigh ;i+=DevideY)
		   g2d.draw(new Line2D.Double(plottableX(0.0)-2,plottableY(i),plottableX(0.0)+2,plottableY(i)));
		  for(double i = 0; i<yhigh; i+=LabelY)
		  { g2d.draw(new Line2D.Double(plottableX(0.0)-5,plottableY(i),plottableX(0.0)+5,plottableY(i)));
		    g2d.drawString(Double.toString(i), (float)plottableX(0)+7,(float)plottableY(i));
		  }

		  for(double i= 0.0; i>ylow;i-=DevideY)
		   g2d.draw(new Line2D.Double(plottableX(0.0)-2,plottableY(i),plottableX(0.0)+2,plottableY(i)));
		  for(double i = 0; i>ylow; i-=LabelY)
		  { g2d.draw(new Line2D.Double(plottableX(0.0)-5,plottableY(i),plottableX(0.0)+5,plottableY(i)));
		    g2d.drawString(Double.toString(i), (float)plottableX(0)+7,(float)plottableY(i));
		  }
	  }
  //x-axis
	  g2d.draw(new Line2D.Double(plottableX(xlow), plottableY(0.0),
	                             plottableX(xhigh),plottableY(0.0)));
  //devide x axis there  are 3 cases
      if(xlow<0 && xhigh<0)//xlow and xhigh are both -ve
      {
		  for(double i= 0.0; i>xlow;i-=DevideX)
		   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-2,plottableX(i),plottableY(0.0)+2));
		  for(double i = 0; i>xlow; i-=LabelX)
		  { g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-5,plottableX(i),plottableY(0.0)+5));
		  	g2d.drawString(Double.toString(i), (float)plottableX(i),(float)plottableY(0.0)+12);
		  }
	  }
      else if(xlow>0 && xhigh>0)//xlow  and xhigh are +ve
      {
		  for(double i= 0.0; i<xhigh; i+=DevideX)
		   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-2,plottableX(i),plottableY(0.0)+2));
		  for(double i= 0.0; i<xhigh; i+=LabelX)
		  { g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-5,plottableX(i),plottableY(0.0)+5));
		    g2d.drawString(Double.toString(i), (float)plottableX(i),(float)plottableY(0.0)+12);
		  }


	  }
      else //xlow  is -ve and xhigh is +ve
      {
		  for(double i= 0.0; i<xhigh ;i+=DevideX)
		   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-2,plottableX(i),plottableY(0.0)+2));
		  for(double i = 0; i<xhigh; i+=LabelX)
		   {
			 if(i==0){}//donothing.. don't draow 0.0..it is already drawn in y_axis
			 else{
			   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-5,plottableX(i),plottableY(0.0)+5));
		       g2d.drawString(Double.toString(i), (float)plottableX(i),(float)plottableY(0.0)+12);
		       }
		   }

		  for(double i= 0.0; i>xlow;i-=DevideX)
		   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-2,plottableX(i),plottableY(0.0)+2));
		  for(double i = 0; i>xlow; i-=LabelX)
		   {
			 if(i==0){}//donothing.. don't draow 0.0..it is already drawn in y_axis
			 else{
			   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-5,plottableX(i),plottableY(0.0)+5));
		       g2d.drawString(Double.toString(i), (float)plottableX(i),(float)plottableY(0.0)+12);
		       }
		   }

	  }
  }

  private double evaluateExpression(double x)
  {
    Equation eq = new Equation(expression);
    double res = eq.Evaluate("x", x);
    return res;
  }
  private double evaluateSlope(double x, double y)
  {
	  Equation eq = new Equation(expression);
	  double res = eq.Evaluate(x, y);
	  return res;
  }

  /*public void displayMPostion(Graphics2D g2d)
  {

	Graphics hg = getGraphics();
	if (hg == null) return;
	hg.setColor(Color.lightGray);
	hg.fillRect(1,1,150,35);
	hg.setColor(Color.blue);
	String xx= Double.toString(MP.getX());
	String yy = Double.toString(MP.getY());
	hg.drawString("x = "+xx, 5, 17);
	hg.drawString("y = "+yy, 5, 30);
	hg.dispose();
  }
*/

  public void paintSlopeField(Graphics g)
  {
	Graphics2D g2d = (Graphics2D) g;
	g2d.setColor(Color.white);

	for(double i=xlow; i<=xhigh; i+=1)  //x values
	{
		double xi = i;
		for(double j=ylow; j<=yhigh; j+=1) //y values
		{
			double yj = j;
			double slope = evaluateSlope(i, j);
			double c = yj - (slope*xi); //c is the y intercept

			double length = 0.3; //the line segment length
			double xDiff = length/Math.sqrt((1+(slope*slope)));

			double x1i = xi - (xDiff);
			double x2i = xi + (xDiff);
			double y1j = (slope*x1i)+ c; double y2j = (slope*x2i)+ c;

			Point2D.Double start = new Point2D.Double(plottableX(x1i),plottableY(y1j));
			Point2D.Double end   = new Point2D.Double(plottableX(x2i),plottableY(y2j));

            g2d.draw(new Line2D.Double(start, end));

		}//for

	}//for
  }
  public double solveDiff(double xo, double yo, double xn, double h)
  {
	  //use RungeKutta class to calculate the solution
	  //of the diff equation
	  RungeKutta rk = new RungeKutta();
	  return rk.Runge_Kutta(expression, xo, yo,xn, h);
  }

  public void paintTrajectory(Graphics g)
  {
	  Graphics2D g2d = (Graphics2D) g;
	  g2d.setColor(Color.white);
	  //g2d.setStroke( new BasicStroke( 1.5f ) );
	  double xo = point.getX(), yo=point.getY(); //initial values

	  double xCord = xo;	double yCord = yo;

	  for(double i= xo+0.01; i<=xhigh; i+=.1)
	  {
		 double xCord2 = i; double yCord2 = solveDiff(xCord, yCord, i, 0.01);
		 Point2D.Double start = new Point2D.Double(plottableX(xCord), plottableY(yCord));
		 Point2D.Double end   = new Point2D.Double(plottableX(xCord2), plottableY(yCord2));
         if((xCord==Double.POSITIVE_INFINITY)||(xCord==Double.NEGATIVE_INFINITY)||
            (yCord2==Double.POSITIVE_INFINITY)||(yCord2==Double.NEGATIVE_INFINITY)){}
         else	 g2d.draw(new Line2D.Double(start, end));

         //Testing by points
		 // g2d.draw(new Ellipse2D.Double(plottableX(i-.3),plottableY(solveDiff(xo, yo, i, 0.1)-.3),.6,.6 ));

		 xCord = xCord2; yCord = yCord2;

	  }
	  xCord = xo;  yCord = yo;

	  for(double i= xo-0.1; i>=xlow; i-=.1)
	  {
		  double xCord2 = i; double yCord2 = solveDiff(xCord, yCord, i, -0.01);
		  Point2D.Double start = new Point2D.Double(plottableX(xCord), plottableY(yCord));
		  Point2D.Double end   = new Point2D.Double(plottableX(xCord2), plottableY(yCord2));
         if((xCord==Double.POSITIVE_INFINITY)||(xCord==Double.NEGATIVE_INFINITY)||
            (yCord2==Double.POSITIVE_INFINITY)||(yCord2==Double.NEGATIVE_INFINITY)){}
         else	 g2d.draw(new Line2D.Double(start, end));
		  xCord = xCord2; yCord = yCord2;


	  }


  }

  public void paint(Graphics g) {

	Graphics2D g2d = (Graphics2D) g;//casting g to g2d
	Graphics2D g2d2 = (Graphics2D) g;//casting g to g2d
    Dimension d = this.getSize();
    g.setColor(Color.blue);
    g.fillRect(0, 0, d.width, d.height);


    paintAxes(g2d);
    //g2d.setStroke( new BasicStroke( 1.0f ) );
	if(slopeFieldDrawer==true)  paintSlopeField(g2d);
    if(trajectoryDrawer ==true) paintTrajectory(g2d);

    //if(positionDisplay  ==true) displayMPostion(g2d);

  }

  public void draw()
  {
	  Graphics g = this.getGraphics();
	  Graphics2D g2d = (Graphics2D) g;
	  if(slopeFieldDrawer ==true) paintSlopeField(g2d);
	  if(trajectoryDrawer ==true) paintTrajectory(g2d);
      //if(positionDisplay  ==true) displayMPostion(g2d);


  }


  public Dimension getMinimumSize() {
    return new Dimension(50, 100);
  }

  public Dimension getPreferredSize() {
    return new Dimension(600, 400);
  }

  public Dimension getMaximumSize() {
    return new Dimension(200, 400);
  }

}
