import java.util.*;

public class RootFinder
{
	static double midValue(double x1, double x2)
	{
		//return the mid value of x1 and x2
		return (x1+x2)/2;
	}
	static double abs(double a)
	{
		//returns the absolute value of a
		if(a==0.0)return 0.0;
		else if(a>0.0) return a;
		else return -1*a;
	}
	static boolean almostequals(double a, double b)
	{
		if(abs(a-b)<0.009)return true;
		else return false;
	}

	private String expression; //the equation
	private double epsilon;



	public RootFinder(String str, double eps)
	{
		expression=str;
		epsilon = eps;//the accuracy in determining the root

	}//public RootFinder()

	public double Evaluate(double a)
	{
		Equation e= new Equation(expression);
		return e.Evaluate("x", a);

	}
	public String firstDerivative()
	{
		//return first derivative of expression
		DerivativeFinder df1 = new DerivativeFinder(expression);
		StringToVectorTokenizer stv1 = new StringToVectorTokenizer(expression);
		Vector<String> ve = stv1.tokenizeToVector();
		return df1.findDerivative(ve);
	}
	public String secondDerivative()
	{
		//returns the second derivative of expression
		DerivativeFinder df1 = new DerivativeFinder(expression);
		StringToVectorTokenizer stv1 = new StringToVectorTokenizer(expression);
		Vector<String> ve = stv1.tokenizeToVector();
		String fd= df1.findDerivative(ve);

		DerivativeFinder df2 = new DerivativeFinder(expression);
		StringToVectorTokenizer stv2 = new StringToVectorTokenizer(fd);
		ve = stv2.tokenizeToVector();
		return df2.findDerivative(ve);
	}
	public double fDEvaluate( double a)
	{
		//return the double value of the 2nd derivative
		String firstDerivative = firstDerivative();
		Equation eq= new Equation(firstDerivative);
		return eq.Evaluate("x", a);
	}
	public double sDEvaluate( double a)
	{
		//return the double value of the 2nd derivative
		String secondDerivative = secondDerivative();
		Equation eq= new Equation(secondDerivative);
		return eq.Evaluate("x", a);
	}

	boolean theFuncSlopeChange(double x1, double x2)
	{
		//return true if the function slope change between x1, x2
		if((fDEvaluate(x1)*fDEvaluate(x2))<0)return true;
		else return false;
	}

	boolean theCurveCrossX(double x1, double x2)
	{
		//return true if the root lies between x1 and x2
		//i.e.. the function has different signs on both ddirections
		double value1 = Evaluate(x1);double value2 = Evaluate(x2);
		if((value1<0.0&&value2>0.0)||(value1>0.0&&value2<0.0))return true;//they are dif in signs
		else return false;
	}
	//find all roots in the interval[v1, v2]taking a step Stepp
	public  Vector<String> findAllRoots(double v1, double v2, double stepp)
	{
		Vector<String> vector = new Vector<String>();//the vector that carries the roots if found
		vector.add("");
		int n=0; //number of times y is +ve
		int m=0; //number of times y = -ve
		for(double k=v1; k<=v2+0.1; k+=stepp)
		{
			if(Evaluate(k)==0.0)vector.add(Double.toString(k));
			else if(Evaluate(k)>0.0)n++;
			else {m++;} //if(Evaluate(k)<0.0)m++;

			if(n>0&&m>0)//there is crossing
			{
				String root =findRootByBisection(k-stepp, k+stepp);
				vector.add(root);
				m=0;n=0;
			}

		}
		for(double k=v1; k<=v2+0.1; k+=stepp)//only detext the touch points
		{
			if(Evaluate(k-stepp)>0&&Evaluate(k+stepp)>0 &&fDEvaluate(k-stepp)<0&&fDEvaluate(k+stepp)>0)
			{
				String root = findRootByNewton(k);
				if(!(root.equals("no root exist"))&&(Double.valueOf(root).doubleValue()>=v1&&
												      Double.valueOf(root).doubleValue()<=v2))
					vector.add(root);
			}
			if(Evaluate(k-stepp)<0&&Evaluate(k+stepp)<0 &&fDEvaluate(k-stepp)>0&&fDEvaluate(k+stepp)<0)
			{
				String root = findRootByNewton(k);
				if(!(root.equals("no root exist"))&&(Double.valueOf(root).doubleValue()>=v1&&
												      Double.valueOf(root).doubleValue()<=v2))
				vector.add(root);
			}
		}
		//adjustiing the vector to be returned
		if(vector.size()==1&&vector.get(0).equals(""))
			vector.set(0, "NaN");
		else vector.remove(0);
		Vector<Double> vect = new Vector<Double>();
		for(int l=0; l<vector.size();l++)
		{
			if(vector.get(l).equals("no root exist")||vector.get(l).equals(""))
			vector.remove(l);
		}
		for(int l=0; l<vector.size()-1;l++)
		{
			double d1=Double.valueOf(vector.get(l)).doubleValue();
			double d2=Double.valueOf(vector.get(l+1)).doubleValue();
			if(almostequals(d1, d2))vector.remove(l);
		}

		return vector;

	}//find all roots

	public String findRootByNewton(double v1)
	{
		double Xno =v1;
		double Xn1 =Xno -(Evaluate(Xno)/fDEvaluate(Xno));//Xno-f(Xno)/f'(Xno)

		if(Evaluate(v1)==0.0)return Double.toString(v1);
		else
		{
			double n =0; //number of iterations after which the fuction terminates
			             //if the roots didn't show up
			while(abs(Xno-Xn1)>epsilon&&n<10)
			{
				if(Evaluate(Xn1)==0) return Double.toString(Xn1);
				else
				{
					Xno=Xn1;
					Xn1=Xno -(Evaluate(Xno)/fDEvaluate(Xno));//Xno-f(Xno)/f'(Xno)
				}
				n++;
			}

		}
		if(abs(Evaluate(Xn1))<=0.009) return Double.toString(Xn1);
		else return "no root exist";
	}//findRootByNewton()

    public String findRootByBisection(double v1, double v2)
    {
		String retString="";
		if(Evaluate(v1)==0.0)return Double.toString(v1);
		else if(Evaluate(v2)==0.0)return Double.toString(v2);
		else if(!(theCurveCrossX(v1, v2)))//have the ame sign
		{
			return "no root exist";
		}
		else
		{
			double L = v1; double R=v2;
			while((R-L)>epsilon)
			{
				double vo=midValue(L, R);
				if(Evaluate(vo)==0.0) return Double.toString(vo);
				else if(theCurveCrossX(L,vo)) R=vo;
				else L=vo;
			}
			double ret=midValue(L,R);
			retString= Double.toString(ret);

		}
		return retString;
	}


	public static void main(String[ ] args)
	{

		Scanner sc = new Scanner(System.in);
		System.out.print("write down the Equation ");
	  	String equation =sc.nextLine();

	  	RootFinder rf = new RootFinder(equation, 0.001);

	  	Scanner sc1 = new Scanner(System.in);
		System.out.print("a =  ");
		String input =sc1.nextLine();
	  	double a = Double.valueOf(input.trim()).doubleValue();
	  	Scanner sc2 = new Scanner(System.in);
		System.out.print("b =  ");
	  	String input2 =sc2.nextLine();
	  	double b = Double.valueOf(input2.trim()).doubleValue();

        String answer1 = rf.findRootByNewton(a);
	  	Vector<String> answer = rf.findAllRoots(a,b, 1);

	  	for(int k=0; k<answer.size();k++)
	  	System.out.print(answer.get(k)+",  ");
	  	//System.out.print(answer1);



	}//main


}//class