/*
  Class StringToVectorTokenizer create an instance that can take
a string and tokenize it, place tokens in vector and return it
using method tokenizeToVector()
Ehab W. Aziz Rezk
Friday 11/17/06
**/
import java.util.*;

public class StringToVectorTokenizer
{
	static  boolean isOperator(String s)
	{//return true if s is an operator
	    if     ( s.equalsIgnoreCase(new String(")"))) return true;
	    else if( s.equalsIgnoreCase(new String("+"))) return true;
	    else if( s.equalsIgnoreCase(new String("-"))) return true;
	    else if( s.equalsIgnoreCase(new String("*"))) return true;
	    else if( s.equalsIgnoreCase(new String("/"))) return true;
	    else if( s.equalsIgnoreCase(new String("^"))) return true;
	    else if( s.equalsIgnoreCase(new String("("))) return true;
	    else                                          return false;
	}//isOperator

	static boolean isOperator2(String s)
	{//return true for sin, cos, tan, cot, sec.
	    if      (s.equalsIgnoreCase(new String("sin")))return  true;
	    else if (s.equalsIgnoreCase(new String("cos")))return  true;
	    else if (s.equalsIgnoreCase(new String("tan")))return  true;
	    else if (s.equalsIgnoreCase(new String("cot")))return  true;
	    else if (s.equalsIgnoreCase(new String("sec")))return  true;
	    else if (s.equalsIgnoreCase(new String("csc")))return  true;
	    else if (s.equalsIgnoreCase(new String("log")))return  true;
	    else if (s.equalsIgnoreCase(new String("exp")))return  true;
	    else                                           return false;
	}//isOprator2()

	static boolean isOperator3(String s)
	{//return true for ln
	    if      (s.equalsIgnoreCase(new String("ln"))) return  true;
	    else                                           return false;
	}//isOprator3()

	static boolean isOperator4(String s)
	{//return true for sqrt, asin, acos,  atan
	    if      (s.equalsIgnoreCase(new String("asin")))return  true;
	    else if (s.equalsIgnoreCase(new String("acos")))return  true;
	    else if (s.equalsIgnoreCase(new String("atan")))return  true;
	    else if (s.equalsIgnoreCase(new String("acot")))return  true;
	    else if (s.equalsIgnoreCase(new String("asec")))return  true;
	    else if (s.equalsIgnoreCase(new String("acsc")))return  true;
	    else if (s.equalsIgnoreCase(new String("sqrt")))return  true;
	    else                                            return false;
	}//isOprator4()

	static boolean isNumber(char s)
	{//return true for numbers
	    boolean returnValue=true;
        { if (s !='.' && s !='0' && s !='1' && s !='2' && s !='3' && s !='4' && s !='5' &&
		                 s !='6' && s !='7' && s !='8' && s !='9' && s !='x' && s !='X' &&
		                 s !='y'&& s !='Y' )
		  returnValue = false;
	    }
	    return returnValue;
	}//isnumber()

	static boolean isPNumber(String s)
	{
		s.trim();
	    boolean returnValue = true;
	    for(int i =0;i<s.length();i++)
		{
			if(!isNumber(s.charAt(i))) returnValue=false;
		}
	    return returnValue;
	}

    static boolean isNNumber(String s)
	{
		s.trim();
		if(s.charAt(0)=='-'&& isPNumber(s.substring(1)))return true;
		else return false;
	}

    static boolean isNumber(String s)
    {
		if(isNNumber(s)||isPNumber(s)) return  true;
		else return false;
	}

	public static void printVector(Vector<String> vec)
	{
		System.out.print("\n");
		for(int i=0; i<vec.size()-1; i++)
		System.out.print(vec.get(i) +", " );
		System.out.print(vec.lastElement() +"\n");
	}

	//the class
	private String string;

	public StringToVectorTokenizer(String st)//constructor
	{
		string = st;
	}

	public String getString()
	{
		return string;
	}

	public Vector<String> tokenizeToVector()
	{
		String str = string.trim();
		Vector<String> tokens = new Vector<String>();



		String temp= str.concat("@");//adding @ at the end of string

		boolean state=true;  int i=0;
		while(state)  //tokenizing the string and pushing it int The vector
		{
			while(temp.charAt(i)==' ') i++;  //removing spaces from tokens

			if(temp.charAt(i)=='(' && temp.charAt(i+1)=='-' &&isNumber(temp.charAt(i+2)))
			{
				//if  char is - followed by number, add- and number as one part
				tokens.add("("); i++;

				String numToken="-"; //then loop to get all digits into numToken string
				i++;
				while(isNumber(temp.charAt(i))&& i<temp.length()-1 )
				{
					numToken= numToken.concat(temp.substring(i,i+1)); i++;
				}
				tokens.add(numToken);
			}
			else if((temp.charAt(i)=='e'||temp.charAt(i)=='E')&&temp.charAt(i+1)!='x')
			{
				tokens.add("e"); i++;
			}
			else if((temp.charAt(i)=='-')&&(temp.charAt(i+1)=='e'||temp.charAt(i+1)=='E')
			        &&temp.charAt(i+1)!='x')
			{
				tokens.add("-e"); i++;i++;
			}
			else if((temp.charAt(i)=='p'|| temp.charAt(i)=='P')&&
			         (temp.charAt(i+1)=='i'||temp.charAt(i+1)=='I') )
			{
				tokens.add("pi"); i++; i++;
			}
			else if((temp.charAt(i)=='-')&&(temp.charAt(i+1)=='p'|| temp.charAt(i+1)=='P')&&
			         (temp.charAt(i+2)=='i'||temp.charAt(i+2)=='I') )
			{
				tokens.add("-pi"); i++; i++; i++;
		    }
			else if( isOperator(temp.substring(i,i+1))  )//if token is operaor
			{
				tokens.add(temp.substring(i,i+1));
				i++; //get the next character
			}
			else  if(isNumber(temp.charAt(i)) ) //if char is number
			{
				String numToken=""; //then loop to get all digits into numToken string
				while(isNumber(temp.charAt(i))&& i<temp.length()-1 )
				{
					numToken= numToken.concat(temp.substring(i,i+1)); i++;
				}
				tokens.add(numToken);
			}//else if
			else if( isOperator2(new String(new char[]{temp.charAt(i),
				                                           temp.charAt(i+1),
				                                           temp.charAt(i+2)} ) )  )
			{
				//if token is sin, cos, tan, exp
				tokens.add(temp.substring(i,i+3)); i+=3;
			}//else if
			else if( isOperator3(new String(new char[]{temp.charAt(i),
														   temp.charAt(i+1)} ) )  )
			{
				//if token is ln
				tokens.add(temp.substring(i,i+2)); i+=2;
			}//else if
			else if( isOperator4(new String(new char[]{temp.charAt(i),temp.charAt(i+1),
				                                           temp.charAt(i+2),temp.charAt(i+3)} ) )  )
			{
				//if token is asin, acos, atan, sqrt
				tokens.add(temp.substring(i,i+4)); i+=4;
			}//else if
			else{tokens.add(temp.substring(i,i+1));i++;}

			if(i==temp.length()-1) state =false;  //one char before @
		}//while(state)

	    //adding the - sign at the beginning of the number followed if found
		if(tokens.get(0).equals("-") && isNumber(tokens.get(1).charAt(0)))
		{
			Vector<String> tempo = new Vector<String>();
			tempo.addElement(new String("-").concat(  tokens.get(1) ) );
			if(tokens.size()>2)
			{
				for(int j=2;j<tokens.size();j++)
				tempo.addElement(tokens.get(j));
			}
			else{}

	        tokens=tempo;
		}else{}

		//changing sin - x, atan - 20... to sin -x, atan -20,...
		for(int k=0; k<tokens.size()-2; k++)
		{
			if( (isOperator2(tokens.get(k))||isOperator3(tokens.get(k))||
				     isOperator3(tokens.get(k))||isOperator4(tokens.get(k)) ) &&
				     tokens.get(k+1).equals("-"))
		    {
				//concatenating tokens(i) with(i+1) and moing succeding elements one cell left
				String stt = tokens.get(k+1).concat(tokens.get(k+2));
				tokens.set(k+1, stt);
				tokens.removeElementAt(k+2);
		    }
			else{}

		}

		return tokens;
	}//tokenize(String)



	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		System.out.print("write down Your string ");
	  	String str =sc.nextLine();
		StringToVectorTokenizer stv = new StringToVectorTokenizer(str);
		printVector(stv.tokenizeToVector());
    }

}//class ExString